#ifndef FTDAPI_H_
#define FTDAPI_H_

/*FTDAPI.h
 *global functions declared here
 */
#include "Config.h"

#if defined (ACE_HAS_TIUSER_H_BROKEN_EXTERN_C)
extern "C" {
#endif

#ifndef NULL
#define NULL 0
#endif

#pragma pack(push)
#pragma pack(1)

	typedef struct tagDateTime
	{
		API_UINT16 year;
		API_BYTE  month,day,hour,minute,second;
		API_UINT16 microsec;
	}Date_Time;

#pragma pack(pop)

typedef int API_BOOL;
#define API_TRUE	1
#define API_FALSE	0

/*߳ģ*/
typedef int THREAD_MODE;
#define SINGLE_THREAD_MODE 0 
#define MULTI_THREAD_MODE 1

/*ʱǷ*/
#define CONNECT_WAIT 1
#define CONNECT_NO_WAIT 0

/**/
typedef int MARKET_ID;
#define MARKET_ZCE 1
#define MARKET_DCE 2
#define MARKET_SFE 3

/*ʼ*/
FTDDLL_API API_BOOL FTDAPI_CALL ftd_api_init(THREAD_MODE mode,const char *LogFilePath,int MonitorPort);
/*ֹͣApi*/
FTDDLL_API void FTDAPI_CALL ftd_api_stop();
/*߳¼*/
FTDDLL_API int FTDAPI_CALL ftd_api_event_loop(double wait=0.001);

/*ݰ*/
FTDDLL_API MsgPackageHandle FTDAPI_CALL API_AllocPackage();
/*ݰ*/
FTDDLL_API void FTDAPI_CALL API_FreePackage(MsgPackageHandle pkg);
/*ݲ*/
/*ID*/
FTDDLL_API int FTDAPI_CALL API_GetPID(MsgPackageHandle pkg);
FTDDLL_API void FTDAPI_CALL API_SetPID(MsgPackageHandle pkg,int pid);
//
#define	FTNULL			0 
#define	FTCHAR			1
#define	FTLONG			2
#define	FTSTRING		3
#define	FTDOUBLE		4
#define	FTDATETIME		5
//ȡĳֶεĵǰ
FTDDLL_API int FTDAPI_CALL API_GetFieldType(MsgPackageHandle pkg,int FieldID);
//ֶβ
//ַ
FTDDLL_API char FTDAPI_CALL API_GFChar(MsgPackageHandle pkg,int fid,char def=' ');
FTDDLL_API void FTDAPI_CALL API_SFChar(MsgPackageHandle pkg,int fid,char val);
//
FTDDLL_API int FTDAPI_CALL API_GFInt(MsgPackageHandle pkg,int fid,int def=0);
FTDDLL_API void FTDAPI_CALL API_SFInt(MsgPackageHandle pkg,int fid,int val);
//˫С
FTDDLL_API double FTDAPI_CALL API_GFDouble(MsgPackageHandle pkg,int fid,double def=0);
FTDDLL_API void FTDAPI_CALL API_SFDouble(MsgPackageHandle pkg,int fid,double val,int precision=4);
//
FTDDLL_API int  FTDAPI_CALL API_GFString(MsgPackageHandle pkg,int fid, char* buf,int bufsize);
FTDDLL_API void FTDAPI_CALL API_SFString(MsgPackageHandle pkg,int fid,const char* buf,int bufsize);
//ʱ
FTDDLL_API API_BOOL FTDAPI_CALL API_GFDateTime(MsgPackageHandle pkg,int fid,Date_Time*val);
FTDDLL_API void FTDAPI_CALL API_SFDateTime(MsgPackageHandle pkg,int fid,  Date_Time*val);

// жĳֶǷΪ
FTDDLL_API API_BOOL FTDAPI_CALL API_FieldIsNull(MsgPackageHandle pkg,int FieldID);
// ĳضֶεֵ
FTDDLL_API void FTDAPI_CALL API_ClearField(MsgPackageHandle pkg,int FieldID);
// ݱֶ
FTDDLL_API void FTDAPI_CALL API_ClearAll(MsgPackageHandle pkg);
// sourceȫƵݰ
FTDDLL_API void FTDAPI_CALL API_Copy(MsgPackageHandle pkg,MsgPackageHandle source);

//ݱ
FTDDLL_API int FTDAPI_CALL API_FirstField(MsgPackageHandle pkg);
FTDDLL_API int FTDAPI_CALL API_NextField(MsgPackageHandle pkg);
FTDDLL_API int FTDAPI_CALL API_CFType(MsgPackageHandle pkg);
FTDDLL_API API_BOOL FTDAPI_CALL API_CFDT(MsgPackageHandle pkg,Date_Time *dt);
FTDDLL_API char FTDAPI_CALL API_CFChar(MsgPackageHandle pkg,char def=' ');
FTDDLL_API int FTDAPI_CALL API_CFInt(MsgPackageHandle pkg,int def=0);
FTDDLL_API double FTDAPI_CALL API_CFDouble(MsgPackageHandle pkg,int *prec=0,double def=0);
FTDDLL_API int  FTDAPI_CALL API_CFString(MsgPackageHandle pkg,char* buf,int bufsize);

FTDDLL_API void FTDAPI_CALL API_Now(Date_Time*dt);


/*Ӷ*/
FTDDLL_API ExchgConnectionHandle FTDAPI_CALL API_CreateExchgConnection(API_BOOL Encrypt,API_BOOL Commpress,MARKET_ID Market
											,int heart_beat_interval,int heart_beat_timeout);
/*뽻*/
FTDDLL_API API_BOOL FTDAPI_CALL API_Connect(ExchgConnectionHandle conn,const char* HostIpAddr,int Port,double Wait);
/*ǷѾ*/
FTDDLL_API API_BOOL API_Connected(ExchgConnectionHandle conn);

/*¼,ҪreqPkgд֤־ŵϢ*/
FTDDLL_API API_BOOL FTDAPI_CALL API_Login(ExchgConnectionHandle conn,MsgPackageHandle reqPkg,double Wait);
/*˳¼,ҪreqPkgд֤־ŵϢ*/
FTDDLL_API API_BOOL FTDAPI_CALL API_Logout(ExchgConnectionHandle conn,MsgPackageHandle reqPkg,double Wait);
/*һݰ*/
FTDDLL_API API_BOOL FTDAPI_CALL API_Send(ExchgConnectionHandle conn,MsgPackageHandle pkg);
/*һݰ
 *wait:ȴwait=0:û
 */
FTDDLL_API MsgPackageHandle FTDAPI_CALL API_Recv(ExchgConnectionHandle conn,double wait=0);
/*Ͽ뽻*/
FTDDLL_API void FTDAPI_CALL API_DisConnect(ExchgConnectionHandle);
/*رղͷŽӶ*/
FTDDLL_API void FTDAPI_CALL API_FreeExchgConnection(ExchgConnectionHandle);

//״̬
#define DFS_CLOSED 0//ӶϿ
#define DFS_OPENED 1//ոս
#define DFS_NEGOTIATEKEY 2//ոЭԿûе¼
#define DFS_LOGIN_OK     3//Ѿ¼ɹ
/*ȡ״̬*/
FTDDLL_API int FTDAPI_CALL API_GetDataFlowStatus(ExchgConnectionHandle,int DataFlowFlag);

/*ݵĻص,ͻķֵAPIԴݰĺʽ
 *0:APIݰݰУͻԵRecvٴȡô˰
 *ط0:APIݰ
 */
typedef int (FTDAPI_CALL*ExchgPackageCallBack)(void * CallBackArg,ExchgConnectionHandle,MsgPackageHandle);
/*״̬Ļص*/
typedef void (FTDAPI_CALL*ExchgConnectionCallBack)(void * CallBackArg,ExchgConnectionHandle,int error_code,const char* error_text);
/*ûص*/
	/*֪ͨerror_code=0ӳɹ0ʧ*/
FTDDLL_API void FTDAPI_CALL API_SetOpenCallBack(ExchgConnectionHandle,ExchgConnectionCallBack,void * CallBackArg);
	/*ӶϿ֪ͨerror_code=0Ͽ0ԶϿ*/
FTDDLL_API void FTDAPI_CALL API_SetCloseCallBack(ExchgConnectionHandle,ExchgConnectionCallBack,void * CallBackArg);
	/*֪ͨ*/
FTDDLL_API void FTDAPI_CALL API_SetErrorCallBack(ExchgConnectionHandle,ExchgConnectionCallBack,void * CallBackArg);

	/*֪ͨ*/
FTDDLL_API void FTDAPI_CALL API_SetRecvCallBack(ExchgConnectionHandle,ExchgPackageCallBack,void * CallBackArg);
	/*¼֪ͨ½ǷɹErrorCode*/
FTDDLL_API void FTDAPI_CALL API_SetLoginCallBack(ExchgConnectionHandle,ExchgPackageCallBack,void * CallBackArg);
	/*¼֪ͨǷɹErrorCode*/
FTDDLL_API void FTDAPI_CALL API_SetLogoutCallBack(ExchgConnectionHandle,ExchgPackageCallBack,void * CallBackArg);

#if defined(ACE_HAS_TIUSER_H_BROKEN_EXTERN_C)
}
#endif

#endif

